#define S0_PIN 2
#define S1_PIN 3
#define S2_PIN 4
#define S3_PIN 5
#define OUT_PIN 6

int red;
int green;
int blue;
int clear;

void setup() {
	Serial.begin(9600);
  
	pinMode(S0_PIN, OUTPUT);
	pinMode(S1_PIN, OUTPUT);
	pinMode(S2_PIN, OUTPUT);
	pinMode(S3_PIN, OUTPUT);  
	pinMode(OUT_PIN, INPUT);
  
	// Power down
	digitalWrite(S0_PIN, LOW);
	digitalWrite(S1_PIN, LOW);
}

void loop() {
  updateRGB();
  
  Serial.print("Rosso: ");
  Serial.print(red);
  Serial.print(" - Verde: ");
  Serial.print(green);
  Serial.print(" - Blu: ");
  Serial.print(blue);
  Serial.print(" - Luce: ");
  Serial.println(clear);
  
  delay(500);
}

void updateRGB() {
  // Frequency 20%
  digitalWrite(S0_PIN, HIGH);
  digitalWrite(S1_PIN, LOW);
  delay(10);
  
  red = 0;  
  green = 0;
  blue = 0;
  clear = 0;

  for (int i = 0; i < 5; i++) {
    digitalWrite(S2_PIN, LOW);
    digitalWrite(S3_PIN, LOW);
    red += pulseIn(OUT_PIN, LOW);
    delay(1);
    
    digitalWrite(S2_PIN, HIGH);
    clear += pulseIn(OUT_PIN, LOW);
    delay(1);
    
    digitalWrite(S3_PIN, HIGH); 
    green += pulseIn(OUT_PIN, LOW);
    delay(1);
    
    digitalWrite(S2_PIN, LOW);
    blue += pulseIn(OUT_PIN, LOW);
    delay(1);
  }
   
  red /= 5;  
  green /= 5;
  blue /= 5;
  clear /= 5; 

  // Power down
  digitalWrite(S0_PIN, LOW);
  digitalWrite(S1_PIN, LOW);
}
